#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
class StoreController < ApplicationController
  def index
    @products = Product.find_products_for_sale
  end


  #START:add_to_cart
  def add_to_cart
    product = Product.find(params[:id])
    @cart = find_cart
    @cart.add_product(product)
  rescue ActiveRecord::RecordNotFound
    logger.error("無効な商品#{params[:id]}にアクセスしようとしました")
    flash[:notice] = "無効な商品です"
    redirect_to :action => 'index'
  end
  #END:add_to_cart

#START:cart
  #START:empty_cart
  def empty_cart
    session[:cart] = nil
    flash[:notice] = "カートは現在空です"
    redirect_to :action => 'index'
  end
  #END:empty_cart

private

  def find_cart
    session[:cart] ||= Cart.new
  end
#END:cart

end