#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
$: << File.dirname(__FILE__)

require "rubygems"
require "activerecord"

require 'connect'

ActiveRecord::Base.logger = Logger.new(STDOUT)

ActiveRecord::Schema.define do 
  create_table :payments, :force => true do |t|
  end
end

class Order < ActiveRecord::Base
end

class Payment < ActiveRecord::Base
end

class Refund < ActiveRecord::Base
end

#START:observer
class OrderObserver < ActiveRecord::Observer
  def after_save(an_order)
    an_order.logger.info("注文#{an_order.id}が作成されました")
  end
end
#END:observer

OrderObserver.instance

#START:multi_observer
class AuditObserver < ActiveRecord::Observer

  observe Order, Payment, Refund

  def after_save(model)
    model.logger.info("[Audit] #{model.class.name} #{model.id}が作成されました")
  end
end
#END:multi_observer

AuditObserver.instance


o = Order.create
p = Payment.create
