#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
# Filters added to this controller apply to all controllers in the application.
# Likewise, all the methods added will be available for all controllers.

class ApplicationController < ActionController::Base
  helper :all # include all helpers, all the time

#START_HIGHLIGHT
  before_filter :cookies_required, :except => [:cookies_test]
#END_HIGHLIGHT

  # See ActionController::RequestForgeryProtection for details
  # Uncomment the :secret if you're not using the cookie session store
  protect_from_forgery # :secret => 'cde978d90e26e7230552d3593d445759'
  
  # See ActionController::Base for details 
  # Uncomment this to filter the contents of submitted sensitive data parameters
  # from your application log (in this case, all fields with names like "password"). 
  # filter_parameter_logging :password

#START_HIGHLIGHT
  def cookies_test
    if request.cookies[SESSION_KEY].blank?
      logger.warn("** Cookies are disabled for #{request.remote_ip} at #{Time.now}")
      render :template => 'cookies_required'
    else
      redirect_to(session[:return_to] || {:controller => "store"})
      session[:return_to] = nil
    end 
  end

protected

  def cookies_required
    return unless request.cookies[SESSION_KEY].blank? 
    session[:return_to] = request.request_uri
    redirect_to :action => "cookies_test"
  end
#END_HIGHLIGHT
end