#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
#START:confirm
#START:sent
class OrderMailer < ActionMailer::Base
#END:sent
  def confirm(order)
    subject    'Pragmaticストアご注文のご確認'
    recipients order.email
    from       'orders@pragprog.com'
    sent_on    Time.now
    
    body       :order => order
  end
#END:confirm

#START:sent
  def sent(order)
    subject    'Pragmaticでのご注文商品を発送しました'
    recipients order.email
    from       'orders@pragprog.com'
    sent_on    Time.now
    
    body       :order => order
  end
#END:sent

#START:sent_with_images
  def ship_with_images(order)
    subject    "Pragmaticでのご注文商品を発送しました"
    recipients order.email
    from       'orders@pragprog.com'
    sent_on    Time.now
    body       "order" => order
    
    part :content_type => "text/html",
         :body => render_message("sent", :order => order)

    order.line_items.each do |li|
      image = li.product.image_location
      content_type = case File.extname(image)
      when ".jpg", ".jpeg";  "image/jpeg"
      when ".png";           "image/png"
      when ".gif";           "image/gif"
      else;                  "application/octet-stream"
      end
    
      attachment :content_type => content_type,
                 :body         => File.read(File.join("public", image)),
                 :filename     => File.basename(image)
    end
  end
#END:sent_with_images

#START:survey
  def survey(order)
    subject    "Pragmaticでのご注文: ご感想をお送りください"
    recipients order.email
    from       'orders@pragprog.com'
    sent_on    Time.now
    body       "order" => order
  end
#END:survey

#START:sent
#START:confirm
end
#END:confirm
#END:sent