#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
#START:test
require 'test_helper'

class OrderMailerTest < ActionMailer::TestCase
  tests OrderMailer

  def setup
    @order = Order.new(:name =>"Dave Thomas", :email => "dave@pragprog.com")
  end

  def test_confirm
    response =  OrderMailer.create_confirm(@order)
    assert_equal("Pragmaticストアご注文のご確認", response.subject)
    assert_equal("dave@pragprog.com", response.to[0])
    assert_match(/Dave Thomas 様/,  response.body)
  end
#END:test

  def test_sent
    response =  OrderMailer.create_sent(@order)
    assert_equal("Pragmaticでのご注文商品を発送しました", response.subject)
    # . . .
  end
    
#START:test
end
#END:test