#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
ActionController::Routing::Routes.draw do |map| 
  
  # 直に'http://my.app/blog/'をインデックスに表示する 
  map.index "blog/", 
            :controller => "blog", 
            :action => "index" 

  # year、year/month、year/month/dayで記事を返す
  map.date "blog/:year/:month/:day", 
           :controller => "blog", 
           :action => "show_date", 
           :requirements => { :year => /(19|20)\d\d/,
                              :month => /[01]?\d/, 
                              :day => /[0-3]?\d/}, 
           :day => nil, 
           :month => nil 

  #START:show_article
  # idで識別された記事を表示する
  map.show_article "blog/show/:id", 
                   :controller => "blog", 
                   :action => "show", 
                   :id => /\d+/ 
  #END:show_article
                
  # 管理用の正規のRailsルーチン
  #START:admin
  map.blog_admin "blog/:controller/:action/:id" 
  #END:admin

  # まずく整形されたリクエストを優雅に処理できるがらくた入れ
  map.catch_all "*anything", 
                :controller => "blog", 
                :action => "unknown_request" 
end