#---
# Excerpted from "Agile Web Development with Rails, 3rd Ed.",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/rails3 for more book information.
#---
class Shipping
    ShippingOption = Struct.new(:id, :name)

    class ShippingType
      attr_reader :type_name, :options
      def initialize(name)
        @type_name = name
        @options = []
      end
      def <<(option)
        @options << option
      end
    end

    ground    = ShippingType.new("遅い")
    ground   << ShippingOption.new(100, "グラウンド小包")
    ground   << ShippingOption.new(101, "メディアメール")

    regular   = ShippingType.new("通常")
    regular  << ShippingOption.new(200, "エアメール")
    regular  << ShippingOption.new(201, "書留郵便")

    priority  = ShippingType.new("速い")
    priority << ShippingOption.new(300, "優先")
    priority << ShippingOption.new(301, "特急")

    OPTIONS = [ ground, regular, priority ]
end